/*
Model Registry REST API

REST API for Model Registry to create and manage ML model metadata

API version: v1alpha3
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
)

// checks if the InferenceServiceList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &InferenceServiceList{}

// InferenceServiceList List of InferenceServices.
type InferenceServiceList struct {
	// Token to use to retrieve next page of results.
	NextPageToken string `json:"nextPageToken"`
	// Maximum number of resources to return in the result.
	PageSize int32 `json:"pageSize"`
	// Number of items in result list.
	Size int32 `json:"size"`
	//
	Items []InferenceService `json:"items"`
}

// NewInferenceServiceList instantiates a new InferenceServiceList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewInferenceServiceList(nextPageToken string, pageSize int32, size int32, items []InferenceService) *InferenceServiceList {
	this := InferenceServiceList{}
	this.NextPageToken = nextPageToken
	this.PageSize = pageSize
	this.Size = size
	this.Items = items
	return &this
}

// NewInferenceServiceListWithDefaults instantiates a new InferenceServiceList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewInferenceServiceListWithDefaults() *InferenceServiceList {
	this := InferenceServiceList{}
	return &this
}

// GetNextPageToken returns the NextPageToken field value
func (o *InferenceServiceList) GetNextPageToken() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.NextPageToken
}

// GetNextPageTokenOk returns a tuple with the NextPageToken field value
// and a boolean to check if the value has been set.
func (o *InferenceServiceList) GetNextPageTokenOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.NextPageToken, true
}

// SetNextPageToken sets field value
func (o *InferenceServiceList) SetNextPageToken(v string) {
	o.NextPageToken = v
}

// GetPageSize returns the PageSize field value
func (o *InferenceServiceList) GetPageSize() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.PageSize
}

// GetPageSizeOk returns a tuple with the PageSize field value
// and a boolean to check if the value has been set.
func (o *InferenceServiceList) GetPageSizeOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.PageSize, true
}

// SetPageSize sets field value
func (o *InferenceServiceList) SetPageSize(v int32) {
	o.PageSize = v
}

// GetSize returns the Size field value
func (o *InferenceServiceList) GetSize() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Size
}

// GetSizeOk returns a tuple with the Size field value
// and a boolean to check if the value has been set.
func (o *InferenceServiceList) GetSizeOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Size, true
}

// SetSize sets field value
func (o *InferenceServiceList) SetSize(v int32) {
	o.Size = v
}

// GetItems returns the Items field value
func (o *InferenceServiceList) GetItems() []InferenceService {
	if o == nil {
		var ret []InferenceService
		return ret
	}

	return o.Items
}

// GetItemsOk returns a tuple with the Items field value
// and a boolean to check if the value has been set.
func (o *InferenceServiceList) GetItemsOk() ([]InferenceService, bool) {
	if o == nil {
		return nil, false
	}
	return o.Items, true
}

// SetItems sets field value
func (o *InferenceServiceList) SetItems(v []InferenceService) {
	o.Items = v
}

func (o InferenceServiceList) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o InferenceServiceList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["nextPageToken"] = o.NextPageToken
	toSerialize["pageSize"] = o.PageSize
	toSerialize["size"] = o.Size
	toSerialize["items"] = o.Items
	return toSerialize, nil
}

type NullableInferenceServiceList struct {
	value *InferenceServiceList
	isSet bool
}

func (v NullableInferenceServiceList) Get() *InferenceServiceList {
	return v.value
}

func (v *NullableInferenceServiceList) Set(val *InferenceServiceList) {
	v.value = val
	v.isSet = true
}

func (v NullableInferenceServiceList) IsSet() bool {
	return v.isSet
}

func (v *NullableInferenceServiceList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableInferenceServiceList(val *InferenceServiceList) *NullableInferenceServiceList {
	return &NullableInferenceServiceList{value: val, isSet: true}
}

func (v NullableInferenceServiceList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableInferenceServiceList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
